local writer = Class(function(self, inst)
    self.inst = inst
    self.sanityvalue = 15
end)


function writer:DoWrite(target, doer)
	
    if target:HasTag("pencilmod_writeable") then	
				
		if doer.components.sanity then
			doer.components.sanity:DoDelta(self.sanityvalue)
		end
		
		if self.inst.components.finiteuses then
			self.inst.components.finiteuses:Use(1)
		end
		 
        if target.components.stackable and target.components.stackable.stacksize > 1 then
            target.components.stackable:Get():Remove()
        else
            target:Remove()
        end
		
		if self.onwritten then
			self.onwritten(self.inst, target, doer)
		end
		
		return true
	end
	
end

function writer:CollectUseActions(doer, target, actions, right)
    if target:HasTag("pencilmod_writeable") then
        table.insert(actions, ACTIONS.PENCILMOD_WRITE)
    end
end

return writer
